<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Http\Helper;
use App\Models\Bookmark;
use App\Models\Post;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class BookmarkController extends Controller
{
    static public function mine()
    {
        if (!Auth::user())
            return [];
        $my_bookmarks = Bookmark::where('user_id', Auth::user()->id)->get();
        return $my_bookmarks;
    }
    static public function addBookmarksToData($data, $bookmarks)
    {
        if (count($bookmarks) < 1 || count($data) < 1)
            return $data;
        foreach ($data as $value) {
            foreach ($bookmarks as $bookmark) {

                $bookmark->post_id == $value->id ? $value->liked = 1 : $value->liked = 0;
            }
        }
        return $data;
    }
    public function bookmarkAction(Request $request, $post_id)
    {
        if (!Post::find($post_id))
            return Helper::return(['message' => __('general.invalid_id', ['entity' => 'Post']),], Response::HTTP_NOT_FOUND);

        $bookmark = Bookmark::where(['user_id' => $request->user()->id, 'post_id' => $post_id])->first();
        $bookmark ?  $bookmark->delete() : Bookmark::create(['user_id' => $request->user()->id, 'post_id' => $post_id]);
        return Helper::return(['message' => __('general.done', ['action' => 'bookmark']),], Response::HTTP_OK);
    }
    public function list()
    {
        return Helper::return(['message' => __('general.fetched', ['entity' => 'bookmarks']), 'data' => $this->mine()], Response::HTTP_OK);;
    }
}
