<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Socialite;
use Symfony\Component\HttpFoundation\Response;

class GoogleController extends Controller
{
    public function handleGoogleCallback()
    {
        try {
            $googleUser = Socialite::driver('google')->stateless()->user();
        } catch (\Exception $e) {
            return response()->json(['message' => 'Google authentication failed.'], Response::HTTP_UNAUTHORIZED);
        }
        $user = User::where('google_id', $googleUser->getId())->first();

        if (!$user) {
            $user = new User();
            $user->name = $googleUser->getName();
            $user->email = $googleUser->getEmail();
            $user->google_id = $googleUser->getId();
            $user->save();
        }
        Auth::login($user);
        $token = $user->createToken('GoogleSignIn')->plainTextToken;

        return response()->json(['message' => 'Google Sign-In successful', 'access_token' => $token], Response::HTTP_OK);
    }
}
