<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Http\Helper;
use App\Models\Setting;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Symfony\Component\HttpFoundation\Response;

class SettingController extends Controller
{
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'section' => 'required|string',
            'key' => 'required|string',
            'value' => 'required|string',
        ]);
        if ($validator->fails()) {
            return Helper::return(['message' => __('general.validation_failed'), 'data' => $validator->errors()], Response::HTTP_BAD_REQUEST);
        }
        if ($setting = Setting::where(['section' => $request->section, 'key' => $request->key])->first()) {
            $setting->value = $request->value;
            $setting->save();
            return Helper::return(['message' => __('general.successfuly_updated', ['entity' => $request->key]), 'data' => Setting::where(['section' => $request->section, 'key' => $request->key])->first()], Response::HTTP_OK);
        }
        $setting = Setting::create($validator->validate());
        return Helper::return(['message' => __('general.created', ['entity' => $request->key]), 'data' => $setting], Response::HTTP_OK);
    }
    public function index()
    {
        return Helper::return(['message' => __('general.fetched', ['entity' => 'Settings']), 'data' => Setting::get()], Response::HTTP_OK);
    }
}
