<?php

namespace App\Http;

use App\Models\File;
use App\Models\Otp;
use App\Models\Salesman;
use Carbon\Carbon;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Str;
use stdClass;

class Helper
{
    static public function makeFileStorable($file, $entity, $sub_section = null, $index = 0, $item_id)
    {
        $array = [];
        foreach ($file  as $key => $value) {
            dd($value);
            $array[$key]['file'] = $value;
            $array[$key]['info'] = ['type' => $entity, 'section' => $key, 'sub_section' => $sub_section, 'item_id' => $item_id, 'index' => $index];
        }
        return $array;
    }
    static public  function storeFile($file)
    {
        foreach ($file as $value) {
            $id = rand(1, 10000);
            $time = time();
            $name = md5($id . $time . $value['file']->getClientOriginalName());
            if (key_exists('index', $value['info'])) {
                $index = $value['info']['index'];
            } else {
                $index = null;
            }
            $created_file[] = File::create([
                'type' => $value['info']['type'],
                'section' => $value['info']['section'],
                'sub_section' => $value['info']['sub_section'],
                'index' => $index,
                'item_id' => $value['info']['item_id'],
                'address' => $name,
                'original_name' => $value['file']->getClientOriginalName(),
                'extension' => $value['file']->extension(),
                'mime_type' => $value['file']->getClientMimeType(),
            ]);
            $value['file']->storeAs('public', $name . '.' . $value['file']->extension());
        }
        return true;
    }
    static public function separateFileFromData($input, $file_keys)
    {
        $file = $data = [];
        foreach ($file_keys as $key => $value) {
            if (key_exists($key, $input)) {
                $file[$key] = $input[$key];
                unset($input[$key]);
            }
        }
        $data = ['file' => $file, 'input' => $input];
        return $data;
    }
    static public function isIDValid($entity, $id)
    {
        if ("App\\Models\\$entity"::find($id)) {
            return true;
        }
        return false;
    }
    static public function return(array $data, $status)
    {
        return response()->json($data, $status);
    }

    public static function sendSms($phone_number, $pattern, $var)
    {
        $apiKey = env('SMS_PANEL');
        $pid = $pattern;
        $fnum = env('SMS_PANEL_NUMBER');
        $url = "http://ippanel.com:8080/?apikey=$apiKey&pid=$pid&fnum=$fnum&tnum=$phone_number&p1=verification-code&v1=$var";
        $response = Http::acceptJson()->get($url);
        $result = new stdClass();
        if ($response->status() == 201) {
            $result->status = true;
            return $result;
        }
        $result->status = false;
        $result->response = $response;
        return $result;
    }
    // public static function makeFilePure(File $file)
    // {
    //     $name = $file ? $file->address . '.' . $file->extension : null;
    //     return ['id' => $file->id, 'name' => $name, 'index' => $file->index];
    // }
    static public function FormPostData($request, $submitor)
    {
        $array = [];
        if ($request->has('feature')) {
            $feature = $request->feature;
        } else {
            $feature = 0;
        }
        if ($request->has('permlink')) {
            $permlink = $request->permlink;
        } else {
            $permlink = '';
        }
        if ($request->has('anchor_website')) {
            $anchor_website = $request->anchor_website;
        } else {
            $anchor_website = '';
        }
        if ($request->has('priority')) {
            $priority = $request->priority;
        } else {
            $priority = 0;
        }
        $array = [
            'title' => $request->post_title,
            'description' => $request->description,
            'featured' => $feature,
            'website' => $request->website,
            'permlink' => $permlink,
            'anchor_website' => $anchor_website,
            'priority' => $priority,
            'created_by' => $request->user()->id,
            'submitor_id' => $submitor,
            'status' => 'Draft',
        ];
        return $array;
    }
}
