<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Category extends Model
{
    use HasFactory, SoftDeletes;
    protected $guarded = [];
    public function icon()
    {
        return $this->hasOne(File::class, 'item_id')->where(['type' => 'Category', 'section' => 'icon']);
    }
    public function post()
    {
        return $this->belongsToMany(Post::class);
    }
    public function postVesion()
    {
        return $this->belongsToMany(PostVersion::class);
    }
    public function detail()
    {
        return $this->hasOne(CategoryDetail::class);
    }
}
